=== python/requirements.txt ===
flatbuffers==2.0
numpy==1.22.0
tflite==2.4.0
