=== debian/changelog ===
arm-compute-library (24.11+dfsg-3) unstable; urgency=medium

  * Source-only upload.

 -- Emanuele Rocca <ema@debian.org>  Sun, 23 Feb 2025 11:32:58 +0100

arm-compute-library (24.11+dfsg-2) unstable; urgency=medium

  * Incomplete dgit upload, trying again.

 -- Emanuele Rocca <ema@debian.org>  Thu, 20 Feb 2025 18:57:12 +0100

arm-compute-library (24.11+dfsg-1) unstable; urgency=medium

  * Update to new upstream version 24.11+dfsg.
  * libarm-compute32 renamed to libarm-compute43 for SONAME bump.
  * Patch SConstruct to honor CXXFLAGS and LDFLAGS.

 -- Emanuele Rocca <ema@debian.org>  Thu, 20 Feb 2025 17:15:26 +0100

arm-compute-library (23.08+dfsg-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1061898

 -- Steve Langasek <vorlon@debian.org>  Wed, 28 Feb 2024 01:23:37 +0000

arm-compute-library (23.08+dfsg-3) unstable; urgency=medium

  * d/rules: enable debug builds if and only if 'debug' is specified in
    DEB_BUILD_OPTIONS.
  * d/salsa-ci.yml: build on arm64 salsa builders by setting
    SALSA_CI_DISABLE_BUILD_PACKAGE_ARM64=0.

 -- Emanuele Rocca <ema@debian.org>  Tue, 09 Jan 2024 09:37:10 +0100
